Subject: Re: [RFC 03/10] base: swnode: use fwnode_get_match_data()

From: Clément Léger <[email-masked]>
Date: Tue, 22 Feb 2022 09:39:21 +0100

Le Mon, 21 Feb 2022 19:48:00 +0200,
Andy Shevchenko <[email-masked]> a écrit :

> On Mon, Feb 21, 2022 at 05:26:45PM +0100, Clément Léger wrote:
> > In order to allow matching devices with software node with
> > device_get_match_data(), use fwnode_get_match_data() for
> > .device_get_match_data operation.  
> 
> ...
> 
> > +	.device_get_match_data = fwnode_get_match_data,  
> 
> Huh? It should be other way around, no?
> I mean that each of the resource providers may (or may not) provide a
> method for the specific fwnode abstraction.
> 

Indeed, it should be the other way. But since this function is generic
and uses only fwnode API I guessed it would be more convenient to
define it in the fwnode generic part and use it for specific
implementation. I could have modified device_get_match_data to call it
if there was no .device_get_match_data operation like this:

const void *device_get_match_data(struct device *dev)
{
	if (!fwnode_has_op(fwnode, device_get_match_data)
		return fwnode_get_match_data(dev);
	return fwnode_call_ptr_op(dev_fwnode(dev),device_get_match_data, dev);
}

But I thought it was more convenient to do it by setting the
.device_get_match_data field of software_node operations.

-- 
Clément Léger,
Embedded Linux and Kernel engineer at Bootlin
https://bootlin.com